# -*- coding: utf-8 -*-

from application.app import db, ma
from datetime import datetime
from .base import PrimaryModel

class AreaModel(PrimaryModel):
    __tablename__ = 'area'

    areaCode = db.Column(db.String(20), index = True)
    areaName = db.Column(db.String(20), index = True)
    level = db.Column(db.Integer, default = 1)
    cityCode = db.Column(db.Integer)
    center = db.Column(db.String(20), index = True)
    parentId = db.Column(db.String(20))
    hasChildren = db.Column(db.Boolean)

    # __table_args__ = (
    #     db.Index('idx_xxx', 'xxx', mysql_using='btree'),
    # )

    def __init__(self, areaCode, areaName, level, cityCode, center, parentId, hasChildren):
        self.areaCode = areaCode
        self.areaName = areaName
        self.level = level
        self.cityCode = cityCode
        self.center = center
        self.parentId = parentId
        self.hasChildren = hasChildren

    def __repr__(self):
        return '<AreaModel %r>' % (self.areaCode)

class AreaSchema(ma.SQLAlchemySchema):
    class Meta:
        model = AreaModel
    areaCode = ma.auto_field()
    areaName = ma.auto_field()
    level = ma.auto_field()
    cityCode = ma.auto_field()
    center = ma.auto_field()
    parentId = ma.auto_field()
    hasChildren = ma.auto_field()

area_schema = AreaSchema()
areas_schema = AreaSchema(many=True)